"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var mishmash_1 = require("mishmash");
exports.default = mishmash_1.default
    .do(mishmash_1.onClickOutside(function (props) { return props.closeModal(); }, 'setModalElem'))
    .do(mishmash_1.fitScreen(function (_a) {
    var baseBounds = _a.baseBounds, style = _a.style;
    return ({
        base: __assign({}, baseBounds, { width: Math.max(baseBounds.width, style.fontSize * 20) }),
        gap: style.fontSize * 0.25,
    });
}))
    .map(mishmash_1.restyle(['fitStyle', 'fitSmall'], function (fitStyle, fitSmall) { return ({
    root: [
        {
            position: 'absolute',
            top: 0,
            right: 0,
            bottom: 0,
            left: 0,
            zIndex: 99999,
        },
    ],
    overlay: [
        {
            position: 'fixed',
            top: 0,
            right: 0,
            bottom: 0,
            left: 0,
            background: 'rgba(0,0,0,0.5)',
        },
    ],
    outer: [
        ['filter', 'borderRadius'],
        [
            'merge',
            __assign({}, fitStyle, { boxShadow: fitSmall
                    ? '0 2px 25px rgba(0,0,0,0.5)'
                    : '0 2px 20px 5px rgba(0,0,0,0.4)' }),
        ],
    ],
    inner: [
        ['scale', { padding: { fontSize: 0.5 } }],
        ['filter', 'background', 'paddingTop', 'paddingBottom'],
    ],
}); }))(function (_a) {
    var modalProps = _a.modalProps, style = _a.style, setModalElem = _a.setModalElem, setRootElem = _a.setRootElem, setInnerElem = _a.setInnerElem, fitSmall = _a.fitSmall, children = _a.children;
    return (React.createElement("div", { className: "e5 e6 e7 e8 e9", style: style.root, ref: setRootElem },
        fitSmall && React.createElement("div", { style: style.overlay }),
        React.createElement("div", __assign({}, modalProps, { style: style.outer, ref: setModalElem }),
            React.createElement("div", { style: style.inner, ref: setInnerElem }, children))));
});
