"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var mishmash_1 = require("mishmash");
var css_1 = require("../../css");
var div_1 = require("../../div");
var txt_1 = require("../../txt");
var Label_1 = require("../components/Label");
var Modal_1 = require("../components/Modal");
var Item_1 = require("./Item");
var withSelect_1 = require("./withSelect");
var withToggle_1 = require("./withToggle");
var isGroup = function (l) { return typeof l === 'string' && l[0] === '~'; };
var userSelect = {
    userSelect: 'none',
    MozUserSelect: 'none',
    msUserSelect: 'none',
    WebkitUserSelect: 'none',
};
exports.default = mishmash_1.default
    .branch(function (_a) {
    var options = _a.options;
    return Array.isArray(options);
}, withSelect_1.default, withToggle_1.default)
    .map(mishmash_1.restyle(['style.layout'], function (layout) { return ({
    base: null,
    group: [
        ['mergeKeys', 'group'],
        __spread([
            'filter'
        ], css_1.default.groups.text, [
            'paddingTop',
            'paddingBottom'
        ], (layout === 'modal' ? ['paddingLeft', 'paddingRight'] : [])),
        ['merge', __assign({ width: '100%' }, userSelect)],
    ],
    keyCell: [
        ['mergeKeys', 'key'],
        ['scale', { paddingRight: { fontSize: 1 } }],
        ['filter', 'padding', 'width'],
        ['merge', { verticalAlign: 'middle' }],
    ],
    keyText: [['mergeKeys', 'key'], __spread(['filter'], css_1.default.groups.text)],
}); }))
    .map(function (_a) {
    var text = _a.text, selectIndex = _a.selectIndex, options = _a.options, labels = _a.labels, labelIndices = _a.labelIndices, selected = _a.selected, activeIndex = _a.activeIndex, moveActiveIndex = _a.moveActiveIndex, props = __rest(_a, ["text", "selectIndex", "options", "labels", "labelIndices", "selected", "activeIndex", "moveActiveIndex"]);
    return (__assign({}, props, { items: __spread((props.style.base.layout === 'table'
            ? [
                React.createElement("td", { style: props.style.keyCell, key: -1 },
                    React.createElement(txt_1.default, { style: props.style.keyText }, text)),
            ]
            : []), labels.map(function (l, i) {
            return isGroup(l) ? (React.createElement(txt_1.default, { style: props.style.group, key: i }, l.substring(1))) : (React.createElement(Item_1.default, { text: l, isList: props.isList, index: labelIndices[i], selectIndex: selectIndex, isSelected: props.isList
                    ? selected[labelIndices[i]]
                    : selected === labelIndices[i], isActive: activeIndex === labelIndices[i], isNone: Array.isArray(options) && !options[labelIndices[i]], moveActiveIndex: moveActiveIndex, style: props.style.base, key: i }));
        })) }));
})
    .map(mishmash_1.restyle(['style.base.layout'], function (layout) { return ({
    base: {
        div: [
            __spread([
                'filter'
            ], (layout !== 'modal'
                ? css_1.default.groups.other
                : ['maxWidth', 'maxHeight'])),
            layout === 'table' && ['mergeKeys', 'row'],
            ['merge', { outline: 'none' }],
        ],
    },
}); }))
    .render(function (_a) {
    var onKeyDown = _a.onKeyDown, hoverProps = _a.hoverProps, focusProps = _a.focusProps, setFocusElem = _a.setFocusElem, style = _a.style, items = _a.items, next = _a.next;
    return React.createElement(style.base.layout === 'table' ? 'tr' : 'div', __assign({ onKeyDown: onKeyDown }, hoverProps, focusProps, { ref: setFocusElem, style: style.div, className: 'e5 e6 e7 e8 e9' }), style.base.layout === 'table' ? items : next());
})
    .branch(function (_a) {
    var style = _a.style;
    return style.base.layout !== 'modal';
}, mishmash_1.default
    .map(mishmash_1.restyle({ base: { base: [['filter', 'layout', 'spacing']] } }))
    .render(function (_a) {
    var items = _a.items, style = _a.style;
    return React.createElement(div_1.default, { style: style.base }, items);
}))
    .do(mishmash_1.renderLifted(function (_a) {
    var closeModal = _a.closeModal, onMouseDown = _a.onMouseDown, hoverProps = _a.hoverProps, setScrollElem = _a.setScrollElem, style = _a.style, items = _a.items, liftBounds = _a.liftBounds;
    return (React.createElement(Modal_1.default, { closeModal: closeModal, modalProps: __assign({ onMouseDown: onMouseDown }, hoverProps, { ref: setScrollElem }), baseBounds: liftBounds, style: style.base, children: items }));
}, function (_a) {
    var isOpen = _a.isOpen;
    return isOpen;
}))
    .map(mishmash_1.restyle(['isFocused'], function (isFocused) { return ({
    base: {
        label: [['merge', userSelect], ['mergeKeys', { active: isFocused }]],
    },
}); }))(function (_a) {
    var value = _a.value, isList = _a.isList, labelText = _a.labelText, openModal = _a.openModal, setLiftBaseElem = _a.setLiftBaseElem, placeholder = _a.placeholder, style = _a.style;
    return (React.createElement("div", { onMouseDown: openModal },
        React.createElement(Label_1.default, { text: value && labelText, iconRight: isList ? 'updown' : 'down', placeholder: placeholder || labelText, setLiftBaseElem: setLiftBaseElem, style: style.label })));
});
