"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var mishmash_1 = require("mishmash");
var undefToNull = function (v) { return (v === undefined ? null : v); };
var mod = function (a, b) { return (a % b + b) % b; };
var modMove = function (start, delta, max) {
    if (start >= 0)
        return mod(start + delta, max);
    return mod(delta > 0 ? delta - 1 : delta, max);
};
exports.default = mishmash_1.default
    .stream(function (_a) {
    var push = _a.push;
    push({ activeIndex: 0, isOpen: false, noScrollRef: false });
    var isOpening = { value: false, timeout: null };
    var isScrolling = false;
    var scrollElem = null;
    var setIsOpen = function (isOpen) {
        isOpening.value = isOpen;
        if (!isOpen)
            clearTimeout(isOpening.timeout);
        isOpening.timeout = isOpen
            ? setTimeout(function () { return (isOpening.value = false); }, 400)
            : null;
        push({ isOpen: isOpen });
    };
    return function (props, _a) {
        var activeIndex = _a.activeIndex, isOpen = _a.isOpen, noScrollRef = _a.noScrollRef;
        var isList = props.isList, value = props.value, onChange = props.onChange, options = props.options, labels = props.labels, _b = props.style, fontSize = _b.fontSize, layout = _b.layout;
        var scrollToIndex = function (index, padding) {
            if (scrollElem) {
                if (!scrollElem.offsetHeight) {
                    push({ noScrollRef: true }, function () { return push({ noScrollRef: false }); });
                }
                else {
                    var item = scrollElem.querySelector("[data-modal-index=\"" + index + "\"]");
                    var top_1 = item.offsetTop - padding;
                    var bottom = top_1 + item.offsetHeight + padding * 2;
                    if (top_1 < scrollElem.scrollTop) {
                        scrollElem.scrollTop = top_1;
                    }
                    if (bottom > scrollElem.scrollTop + scrollElem.offsetHeight) {
                        scrollElem.scrollTop = bottom - scrollElem.offsetHeight;
                    }
                }
            }
        };
        var selectIndex = function (index) {
            if (!isOpening.value) {
                push({ activeIndex: index });
                if (!isList) {
                    onChange(undefToNull(options[index]));
                }
                else {
                    var newValue = options.filter(function (o, i) {
                        return i === index
                            ? !(value || []).includes(o)
                            : (value || []).includes(o);
                    });
                    onChange(newValue.length > 0 ? newValue : null);
                }
                if (!isList)
                    setIsOpen(false);
            }
        };
        var moveActiveIndex = function (move, jumpTo) {
            if (move === undefined) {
                selectIndex(activeIndex);
            }
            else {
                if (isScrolling && jumpTo) {
                    isScrolling = false;
                }
                else {
                    var newActiveIndex = jumpTo
                        ? move
                        : modMove(activeIndex, move, options.length);
                    if (!isList && layout !== 'modal')
                        selectIndex(newActiveIndex);
                    else
                        push({ activeIndex: newActiveIndex });
                    if (layout === 'modal')
                        isScrolling = true;
                    scrollToIndex(newActiveIndex, parseFloat(fontSize) * 0.5);
                }
            }
        };
        var onKeyDown = function (event) {
            if (layout === 'modal' && !isOpen) {
                if (event.keyCode === 13 || event.keyCode === 32) {
                    setIsOpen(true);
                    event.preventDefault();
                }
            }
            else {
                if (event.keyCode === 13 || event.keyCode === 32) {
                    moveActiveIndex();
                    if (!isList)
                        setIsOpen(false);
                    event.preventDefault();
                }
                else if (event.keyCode === 37 || event.keyCode === 38) {
                    moveActiveIndex(-1);
                    event.preventDefault();
                }
                else if (event.keyCode === 39 || event.keyCode === 40) {
                    moveActiveIndex(1);
                    event.preventDefault();
                }
                else if (event.keyCode === 9 || event.keyCode === 27) {
                    setIsOpen(false);
                }
            }
            if (event.keyCode === 13) {
                event.stopPropagation();
            }
        };
        var newLabels = (labels || options || []).map(function (o) { return (o === null ? '-- None --' : o.toString()); });
        var labelIndices = [];
        var labelIndex = 0;
        var filteredLabels = newLabels.filter(function (l) {
            var group = typeof l === 'string' && l[0] === '~';
            labelIndices.push(group ? -1 : labelIndex);
            if (!group)
                labelIndex++;
            return !group;
        });
        return __assign({}, props, { activeIndex: activeIndex, labels: newLabels, labelIndices: labelIndices, labelText: !isList
                ? filteredLabels[options.indexOf(value)] || ''
                : filteredLabels
                    .filter(function (_, i) { return (value || []).includes(options[i]); })
                    .join(', '), selected: !isList
                ? options.indexOf(value)
                : (value || []).reduce(function (result, v) {
                    return (__assign({}, result, (_a = {}, _a[options.indexOf(v)] = true, _a)));
                    var _a;
                }, {}), selectIndex: selectIndex,
            moveActiveIndex: moveActiveIndex,
            onKeyDown: onKeyDown }, (layout === 'modal'
            ? __assign({ isOpen: isOpen, openModal: function () { return setIsOpen(true); }, closeModal: function () { return setIsOpen(false); }, setScrollElem: function (elem) {
                    scrollElem = elem;
                    if (isList ? value && value.length > 0 : value) {
                        var index = options.indexOf(isList ? value[0] : value);
                        push({ activeIndex: index });
                        scrollToIndex(index, parseFloat(fontSize) * 0.5);
                    }
                } }, (noScrollRef ? { setScrollElem: null } : {})) : {}));
    };
})
    .cache('labels', 'labelIndices', 'selectIndex', 'moveActiveIndex', 'onKeyDown', 'openModal', 'closeModal', 'setScrollElem');
