"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var mishmash_1 = require("mishmash");
var Label_1 = require("../components/Label");
var parsers_1 = require("./parsers");
exports.default = mishmash_1.default
    .stream(function (_a) {
    var initial = _a.initial, observe = _a.observe, push = _a.push;
    var state = { props: {}, text: '', config: {} };
    var onTextChange = function (text) {
        var _a = state.props, type = _a.type, value = _a.value, onChange = _a.onChange;
        var parsed = text
            ? parsers_1.default[type].parse(text, state.props)
            : { value: null };
        state.config = parsed.config || {};
        state.text = parsed.text !== undefined ? parsed.text : text;
        if (!parsers_1.default[type].equals(value, parsed.value))
            onChange(parsed.value);
        else
            push({ text: state.text });
        state.props.onTextChange && state.props.onTextChange(state.text);
    };
    var update = function (props) {
        if (props && props.value !== state.props.value) {
            var newText = props.value === null &&
                parsers_1.default[props.type].parse(state.text, props).value === null
                ? state.text
                : parsers_1.default[props.type].format(props.value, state.config, props);
            push({ text: newText });
            props.onTextChange && props.onTextChange(newText);
        }
        state.props = props;
    };
    observe(update);
    update(initial);
    return function (props, _a) {
        var text = _a.text;
        return (__assign({}, props, { text: text,
            onTextChange: onTextChange }, (props.password ? { iconRight: 'lock' } : {}), (props.type === 'date'
            ? {
                placeholder: props.placeholder || (props.noDay ? 'MM/YY' : 'DD/MM/YY'),
                iconRight: text && (props.value === null ? 'cross' : 'tick'),
            }
            : {}), (props.type === 'stringlist'
            ? {
                rows: (props.value || ['']).length + 1,
                placeholder: __spread([
                    'Option 1'
                ], (props.value || ['']).map(function (_, i) { return "Option " + (i + 2); })).join('\n'),
                prompt: true,
            }
            : {})));
    };
})
    .map(mishmash_1.restyle(['isFocused'], function (isFocused) { return ({
    div: [
        [
            'filter',
            'display',
            'width',
            'height',
            'maxWidth',
            'maxHeight',
            'verticalAlign',
        ],
    ],
    label: [
        ['mergeKeys', { active: isFocused }],
        ['merge', { display: 'block', cursor: 'text' }],
    ],
}); }))(function (_a) {
    var text = _a.text, onTextChange = _a.onTextChange, iconLeft = _a.iconLeft, iconRight = _a.iconRight, placeholder = _a.placeholder, prompt = _a.prompt, rows = _a.rows, password = _a.password, tab = _a.tab, spellCheck = _a.spellCheck, onMouseDown = _a.onMouseDown, onKeyDown = _a.onKeyDown, hoverProps = _a.hoverProps, focusProps = _a.focusProps, setFocusElem = _a.setFocusElem, style = _a.style;
    return (React.createElement("div", __assign({ onMouseDown: onMouseDown, onKeyDown: onKeyDown }, hoverProps, { style: style.div, className: "e5 e6 e7 e8 e9" }),
        React.createElement(Label_1.default, { text: text, onTextChange: onTextChange, iconLeft: iconLeft, iconRight: iconRight, placeholder: placeholder, prompt: prompt, rows: rows, password: password, tab: tab, spellCheck: spellCheck, focusProps: focusProps, setFocusElem: setFocusElem, style: style.label })));
});
