"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var mishmash_1 = require("mishmash");
var css_1 = require("../css");
var Autosize_1 = require("./Autosize");
var Placeholder_1 = require("./Placeholder");
var cssTransforms_1 = require("./cssTransforms");
var getMargin = function (style) {
    var gap = (parseFloat(style.lineHeight) - parseFloat(style.fontSize)) * 0.5;
    return "-" + (gap + 1) + "px 0px -" + (gap + 1) + "px";
};
var omit = function () {
    var keys = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        keys[_i] = arguments[_i];
    }
    return function (obj) {
        return Object.keys(obj)
            .filter(function (k) { return !keys.includes(k); })
            .reduce(function (res, k) {
            return (__assign({}, res, (_a = {}, _a[k] = obj[k], _a)));
            var _a;
        }, {});
    };
};
var createTxt = function (input) {
    var base = mishmash_1.default
        .do(input ? mishmash_1.focusable('setFocusElem', 'onMouseDown') : mishmash_1.default)
        .pure()
        .map(mishmash_1.restyle([
        [
            'defaults',
            {
                fontSize: 16,
                lineHeight: 1.5,
                cursor: input ? 'text' : undefined,
            },
        ],
        ['block'],
        ['lineHeightPx'],
    ], cssTransforms_1.default))
        .render(mishmash_1.default
        .map(mishmash_1.restyle(['style.fontSize'], function (fontSize) { return ({
        outer: [
            ['filterKeys'],
            __spread(['filter'], css_1.default.groups.box, css_1.default.groups.other),
        ],
        inner: [
            { padding: '1px 0px', display: 'block', minHeight: fontSize },
        ],
    }); }))
        .map(omit.apply(void 0, __spread(['placeholder'], (input
        ? [
            'onTextChange',
            'placeholder',
            'prompt',
            'rows',
            'password',
            'tab',
            'tabIndex',
            'onFocus',
            'onBlur',
            'focusElem',
            'setFocusElem',
            'focusRef',
            'spellCheck',
        ]
        : []))))(function (_a) {
        var style = _a.style, next = _a.next, props = __rest(_a, ["style", "next"]);
        return (React.createElement("span", __assign({ style: style.outer }, props, { className: (props.className || '') + " e5 e6 e7 e8 e9" }),
            React.createElement("span", { style: style.inner }, next())));
    }))
        .map(mishmash_1.restyle({
        text: [['filterKeys'], __spread(['filter'], css_1.default.groups.text)],
        placeholder: [
            ['mergeKeys', 'placeholder'],
            __spread(['filter'], css_1.default.groups.text),
        ],
    }));
    if (!input) {
        return base.map(function (_a) {
            var children = _a.children, placeholder = _a.placeholder, style = _a.style;
            return ({
                children: children || placeholder,
                style: children ? style.text : style.placeholder,
            });
        })(function (_a) {
            var style = _a.style, children = _a.children;
            return (React.createElement("span", { style: __assign({}, style, { display: 'block', margin: getMargin(style) }) }, React.Children.toArray(children).reduce(function (result, child, i) {
                return result.concat(typeof child === 'string'
                    ? child
                        .split('\n')
                        .reduce(function (res, line, j) {
                        return res.concat(j === 0 ? line : [React.createElement("br", { key: i + "_" + j }), line]);
                    }, [])
                    : child);
            }, [])));
        });
    }
    return base
        .map(mishmash_1.restyle({
        text: {
            input: [
                [
                    'merge',
                    {
                        position: 'absolute',
                        top: 0,
                        left: 0,
                        width: '100%',
                        height: '100%',
                        resize: 'none',
                        overflow: 'hidden',
                        background: 'transparent',
                        outline: 'none',
                        border: 0,
                        padding: 0,
                        margin: 0,
                        display: 'block',
                    },
                ],
            ],
        },
    }))
        .map(function (_a) {
        var children = _a.children, props = __rest(_a, ["children"]);
        var v = (children || '').toString();
        return __assign({}, props, { value: props.rows === undefined ? v.replace(/\n/g, '') : v });
    })
        .map(function (_a) {
        var tabIndex = _a.tabIndex, onFocus = _a.onFocus, onBlur = _a.onBlur, setFocusElem = _a.setFocusElem, onTextChange = _a.onTextChange, spellCheck = _a.spellCheck, value = _a.value, props = __rest(_a, ["tabIndex", "onFocus", "onBlur", "setFocusElem", "onTextChange", "spellCheck", "value"]);
        return (__assign({}, props, { value: value, inputProps: {
                value: value,
                onChange: function (event) { return onTextChange(event.target.value); },
                onKeyDown: function (event) {
                    if (event.keyCode === 13) {
                        if (props.rows === undefined)
                            event.preventDefault();
                        else
                            event.stopPropagation();
                    }
                },
                tabIndex: tabIndex,
                onFocus: onFocus,
                onBlur: onBlur,
                ref: function (elem) { return setFocusElem(elem); },
                spellCheck: spellCheck,
                size: 1,
                style: props.style.input,
            } }));
    })(function (_a) {
        var placeholder = _a.placeholder, prompt = _a.prompt, rows = _a.rows, password = _a.password, style = _a.style, value = _a.value, inputProps = _a.inputProps;
        return (React.createElement("span", { style: {
                position: 'relative',
                display: 'block',
                margin: getMargin(style.text),
            } },
            React.createElement(Autosize_1.default, { value: value || placeholder, rows: rows, style: style.text }),
            React.createElement(Placeholder_1.default, { text: placeholder, value: value, prompt: prompt, style: style.placeholder }),
            password ? (React.createElement("input", __assign({ type: "password" }, inputProps))) : (React.createElement("textarea", __assign({}, inputProps)))));
    });
};
exports.default = createTxt();
exports.TxtInput = createTxt(true);
